<?php



/**
 * @author Maciej Łotysz - maciejlotysz[at]gmail[dt]com
 * 
 */

defined('_JEXEC') or die('Restricted access');


class cr_eservices {
    private $_paymentServer = 'https://pay.eservice.com.pl';
    private $_merchantId = '720000000000756';
    private $_merchantPassword = 'dD3d8HBhDZ';
    private $_okUrl = 'http://sklepmedycznymragowo.pl/eservice/ok.php';
    private $_failUrl = 'http://sklepmedycznymragowo.pl/eservice/fail.php';
    private $_pendingUrl = 'http://sklepmedycznymragowo.pl/eservice/pending.php';
    
    private $_virtuemartOrderId = 0;
    private $_DBO = null;
    private $_DBVmPrefix = 'sp';
    private $_virtuemartOrders_DBdata;   // #__virtuemart_orders
    private $_virtuemartOrderItems_DBdata;   // #__virtuemart_order_items
    private $_virtuemartOrderUserinfos_DBdata;   // #__virtuemart_order_userinfos
    private $_orderData;
    private $_VERSION = '0.02';

    public function __construct($virtuemartOrderId) 
    {       
        $this->_DBO = JFactory::getDbo();
        $this->_virtuemartOrderId = $virtuemartOrderId;
        $this->getOrderVMInfo();
        $this->_orderData = $this->getOrderData();
    }
    
    // template formy i button - juz wszystko  obliczone
    public function getPayForm()
    {
        $formHTML = "";   
        $formHTML .= "<form method='post' action='".$this->_paymentServer."/fim/eservicegate' id='payment-form'> \n";
        $formHTML .= $this->generateFormInptuElements();
        $formHTML .= "<button type='submit' formtarget='_blank' class='btn btn-success'>Opłać teraz&nbsp;&nbsp;&nbsp;<i class='fa fa-credit-card'></i></button>\n";
        $formHTML .= "</form>\n";

        return $formHTML;
    }
    
    
    private function generateFormInptuElements()
    { 
        $formHTML = "";
        foreach ($this->_orderData as $key => $value) 
        {
            $formHTML .= "<input type='hidden' name='".$key."' value='".$value."' />\n";
        }
        return $formHTML;
    }
    
    /**
     * default styles for form 
     * @return string
     */
    public function getStyle()
    {
        return "<style>  </style>";
    }
    
    private function getOrderData()
    {
        $orderData = array();
       
        
        $orderData['ClientId'] = $this->_merchantId;
        $orderData['StoreType'] = '3d_pay_hosting'; 
        $orderData['Token'] = $this->getToken();
        $orderData['TranType'] = 'Auth'; 
        $orderData['Total'] = $this->getTotalAmount(); 
        $orderData['Currency'] = '985'; 
        $orderData['OrderId'] = $this->getDescription(); 
        $orderData['ConsumerName'] = $this->_virtuemartOrderUserinfos_DBdata[0]['first_name']; // imie
        $orderData['ConsumerSurname'] = $this->_virtuemartOrderUserinfos_DBdata[0]['last_name'];   // nazwisko
        $orderData['okUrl'] = $this->_okUrl; 
        $orderData['failUrl'] = $this->_failUrl; 
        $orderData['pendingUrl'] = $this->_pendingUrl; 
        $orderData['lang'] = 'pl'; 
        $orderData['BillToName'] = $orderData['ConsumerName'].' '.$orderData['ConsumerSurname']; // imie nazwisko
        $orderData['BillToPostalCode'] = $this->_virtuemartOrderUserinfos_DBdata[0]['zip'];  // kod pocztowy
        $orderData['BillToStreet1'] = $this->_virtuemartOrderUserinfos_DBdata[0]['address_1']; // ulica
        $orderData['BillToCity'] = $this->_virtuemartOrderUserinfos_DBdata[0]['city'];  // miasto
        $orderData['BillToCountry'] = 'PL'; 
        $orderData['ShipToName'] = $orderData['BillToName'];
        $orderData['ShipToPostalCode'] = $orderData['BillToPostalCode'];
        $orderData['ShipToStreet1'] = $orderData['BillToStreet1'];
        $orderData['ShipToCity'] = $orderData['BillToCity'];
        $orderData['ShipToCountry'] = $orderData['BillToCountry']; 
        
        return $orderData;
    }
    
    /**
     * return description for order, note from order + order number
     * @return string
     */
    private function getDescription()
    {
        return $this->_virtuemartOrders_DBdata[0]['order_number'];
    }
    
    /**
     * return total order total price
     * @return int 
     */
    private function getTotalAmount()
    {
        return $this->getPriceInSmalesValue($this->_virtuemartOrders_DBdata[0]['order_total']);
    }
    
    /**
     * return total price in 'grosze'
     * @return int 
     */    
    private function getPriceInSmalesValue($price)
    {
        return number_format($price, 2, '.', '');
    }
    
    private function getToken()
    {
	$hstable="ClientId=".$this->_merchantId."&Password=".$this->_merchantPassword."&OrderId=".$this->getDescription()."&Total=".$this->getTotalAmount()."&Currency=985";
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL, $this->_paymentServer."/pg/token");
	curl_setopt($ch, CURLOPT_HEADER, 0);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
	curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, FALSE);
	//curl_setopt($ch, CURLOPT_SSLVERSION, 6);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_POST, 1);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $hstable);

	$result = curl_exec($ch);
	curl_close ($ch);       
        
        $tokenInfo = array();
        $t = explode("&", $result);
        foreach ($t as $v)
        {
            $tmp = explode("=", $v);
            $tokenInfo[$tmp[0]] = $tmp[1];
        }
        
        return $tokenInfo['msg'];
    }
    

    /**
     * sets var with order data info from VM database 
     */
    private function getOrderVMInfo()
    {
        $query_virtuemartOrders = "SELECT * FROM `".$this->_DBVmPrefix."_virtuemart_orders` WHERE `virtuemart_order_id` = ".$this->_virtuemartOrderId;
        $this->_DBO->setQuery($query_virtuemartOrders);
        $this->_DBO->query();
        $this->_virtuemartOrders_DBdata = $this->_DBO->loadAssocList();
        //print_r($this->_virtuemartOrders_DBdata);
        
        $query_virtuemartOrderItems = "SELECT * FROM `".$this->_DBVmPrefix."_virtuemart_order_items` WHERE `virtuemart_order_id` = ".$this->_virtuemartOrderId;
        $this->_DBO->setQuery($query_virtuemartOrderItems);
        $this->_DBO->query();
        $this->_virtuemartOrderItems_DBdata = $this->_DBO->loadAssocList();
        //print_r($this->_virtuemartOrderItems_DBdata);        
        
        $query_virtuemartOrderUserinfos = "SELECT * FROM `".$this->_DBVmPrefix."_virtuemart_order_userinfos` WHERE `virtuemart_order_id` = ".$this->_virtuemartOrderId;
        $this->_DBO->setQuery($query_virtuemartOrderUserinfos);
        $this->_DBO->query();
        $this->_virtuemartOrderUserinfos_DBdata = $this->_DBO->loadAssocList();
        //print_r($this->_virtuemartOrderItems_DBdata);                
        
    }
    
   
    public function version()
    {
        return $this->_VERSION;
    }
    

}
