<?php

defined('_JEXEC') or die('Restricted access');

class templates
{
    private $currentDir = null;
    private $templateDir = null;
    private $templateVars = array('{SUBJECT}', '{DOMAIN}', '{HEADER}', '{EMAIL_BODY}');
    
    private $template = null;
    private $params = null;
    
    /**
     * $params = array(
     *          {SUBJECT} - string
     *          {DOMAIN} - string url
     *          {HEADER} - string
     *          {EMAIL_BODY} - string html
     *              )
     * 
     * @param string $template - template name
     * @param array $params 
     * @return html string if template exist otherwise null
     */
    public function __construct($template, $params)
    {
        $this->currentDir = dirname(__FILE__);
        $this->templateDir = $this->currentDir.DIRECTORY_SEPARATOR.'templates'.DIRECTORY_SEPARATOR;
        
        $this->template = $template;
        $this->params = $params;
        

        return null;
    }
    
    public function getHtmlTemplate()
    {
        $templateFile = $this->loadTemaplateFile($this->template);
        if(!empty($templateFile))
        {
            return $this->prepareTemplate($templateFile, $this->params);
        }
    }
    
    /**
     * @param string $template - look at constructor
     * @return html string template if template exist otherwise null
     */
    private function loadTemaplateFile($template)
    {
        $templatesFiles = array(
            'email01' => 'email01.html',
        );
        $templateFile = $templatesFiles[$template];
        if($templateFile)
        {
            return file_get_contents($this->templateDir.$templateFile);
        }
        return null;
    }
    
    /**
     * @param string $templateFile - html string from template file
     * @param array $params - look at constructor
     */
    private function prepareTemplate($templateFile, $params)
    {
        return str_replace($this->templateVars, $params, $templateFile);
    }
}
