<?php


class bowart
{
    private $dbStmt;
    private $domain;
    private $currentQuery = "";


    public function __construct()
    {
        $this->dbStmt = JFactory::getDbo();     
        $this->domain = 'http://sklepmedycznymragowo.pl/';
    }
    
    /**
     * 
     * @param string $where example  " AND `catid` IN (1,2,3) "
     * @param string $order example  " created "
     * @param string $orderSort  ASC or DESC
     * @param int $limit limit int value
     */
    public function getContent($where = null, $order = null, $orderSort = 'ASC', $limit = null)
    {
        $query = "SELECT * FROM `#__content` WHERE `state` = '1'";
        if($where)
        {
            $query .= " ".$where." ";         
        }
        if($order)
        {
            $query .= " ORDER BY `".$order."` ".$orderSort." ";
        }
        if($limit)
        {
            $query .= " LIMIT ".  intval($limit)." ";
        }        
        
        $this->currentQuery = $query;
        
        return $this->getContentQuery($query);
    }
    
    public function getContentQuery($query)
    {
        $this->dbStmt->setQuery($query);
        $this->dbStmt->query();
        return $this->parseContentFromDB($this->dbStmt->loadAssocList());
    }    
    
    public function getQueryString()
    {
        return $this->currentQuery;
    }
    
    protected function parseContentFromDB($content)
    {
        $resault = array();
        foreach ($content as $k => $value)
        {
            $resault[$k]['id'] = $value['id'];
            $resault[$k]['title'] = $value['title'];
            $resault[$k]['introtext'] =  $this->clearHtml($value['introtext']) ;
            $resault[$k]['image'] = $this->getImageIntroFromContent($value['images']);
            $resault[$k]['link'] = $this->getLinkFromContent($value);
            $resault[$k]['date'] = $value['publish_up'];
            $resault[$k]['created_by'] = $value['created_by'];
            $resault[$k]['hits'] = $value['hits'];
            $resault[$k]['created_by_alias'] = $value['created_by_alias'];
        }
        return $resault;
    }    
    
    protected function clearHtml($str)
    {
        $str = str_replace('<strong>', '', $str);
        $str = str_replace('</strong>', '', $str);
        //$str = str_replace('<p>', '', $str);
        //$str = str_replace('</p>', '', $str);
        $str = str_replace('<br />', '', $str);
        $str = trim($str);
        return $str;
    }
    
    protected function getImageIntroFromContent($json)
    {
        $image = json_decode($json);
        return $this->domain.''.$image->image_intro;
    }
    
    protected function getLinkFromContent($content)
    {
        return $this->domain.''
                .$this->getCategoryFromCatid($content['catid']).'/'
                .$content['id'].'-'.$content['alias'];
    }
    
    public function getCategoryFromCatid($catid)
    {
        $query = "SELECT * FROM `#__categories` WHERE `id` = '".$catid."'";
        $this->dbStmt->setQuery($query);
        $this->dbStmt->query();
        $resault = $this->dbStmt->loadAssocList();
        return $resault[0]['alias'];
    }    
    
    public function getCategoryNameFromCatid($catid)
    {
        $query = "SELECT * FROM `#__categories` WHERE `id` = '".$catid."'";
        $this->dbStmt->setQuery($query);
        $this->dbStmt->query();
        $resault = $this->dbStmt->loadAssocList();
        return $resault[0]['title'];
    }        
}
