<?php
/**
 *
 * Show the product details page
 *
 * @package	VirtueMart
 * @subpackage
 * @author Max Milbers, Eugen Stranz, Max Galt
 * @link http://www.virtuemart.net
 * @copyright Copyright (c) 2004 - 2014 VirtueMart Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
 * VirtueMart is free software. This version may have been modified pursuant
 * to the GNU General Public License, and as distributed it includes or
 * is derivative of works licensed under the GNU General Public License or
 * other free or open source software licenses.
 * @version $Id: default.php 8715 2015-02-17 08:45:23Z Milbo $
 */
// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die('Restricted access');

/* Let's see if we found the product */
if (empty($this->product)) {
	echo vmText::_('COM_VIRTUEMART_PRODUCT_NOT_FOUND');
	echo '<br /><br />  ' . $this->continue_link_html;
	return;
}

echo shopFunctionsF::renderVmSubLayout('askrecomjs',array('product'=>$this->product));


$WYPOZYCZALNIA = ($this->product->canonCatId == 33) ? true : false;



if(vRequest::getInt('print',false)){ ?>
<body onload="javascript:print();">
<?php } ?>

<div class="productdetails-view productdetails">

    
    <?php // Product Title   ?>
    <div class="page-header">
        <h1><?php echo $this->product->product_name ?></h1>     
    </div>    
    <?php // Product Title END   ?>    
    


	<?php // Back To Category Button
	if ($this->product->virtuemart_category_id) {
		$catURL =  JRoute::_('index.php?option=com_virtuemart&view=category&virtuemart_category_id='.$this->product->virtuemart_category_id, FALSE);
		$categoryName = $this->product->category_name ;
	} else {
		$catURL =  JRoute::_('index.php?option=com_virtuemart');
		$categoryName = vmText::_('COM_VIRTUEMART_SHOP_HOME') ;
	}
	?>
	<div class="back-to-category">
    	<a href="<?php echo $catURL ?>" class="product-details" title="<?php echo $categoryName ?>"><?php echo vmText::sprintf('COM_VIRTUEMART_CATEGORY_BACK_TO',$categoryName) ?></a>
	</div>



    <?php // afterDisplayTitle Event
    echo $this->product->event->afterDisplayTitle ?>

    <?php
    // Product Edit Link
    echo $this->edit_link;
    // Product Edit Link END
    ?>

    <?php
    // PDF - Print - Email Icon
    if (VmConfig::get('show_emailfriend') || VmConfig::get('show_printicon') || VmConfig::get('pdf_icon')) {
	?>
        <div class="icons">
	    <?php

	    $link = 'index.php?tmpl=component&option=com_virtuemart&view=productdetails&virtuemart_product_id=' . $this->product->virtuemart_product_id;

		echo $this->linkIcon($link . '&format=pdf', 'COM_VIRTUEMART_PDF', 'pdf_button', 'pdf_icon', false);
	    //echo $this->linkIcon($link . '&print=1', 'COM_VIRTUEMART_PRINT', 'printButton', 'show_printicon');
		echo $this->linkIcon($link . '&print=1', 'COM_VIRTUEMART_PRINT', 'printButton', 'show_printicon',false,true,false,'class="printModal"');
		$MailLink = 'index.php?option=com_virtuemart&view=productdetails&task=recommend&virtuemart_product_id=' . $this->product->virtuemart_product_id . '&virtuemart_category_id=' . $this->product->virtuemart_category_id . '&tmpl=component';
	    echo $this->linkIcon($MailLink, 'COM_VIRTUEMART_EMAIL', 'emailButton', 'show_emailfriend', false,true,false,'class="recommened-to-friend"');
	    ?>
    	<div class="clear"></div>
        </div>
    <?php } // PDF - Print - Email Icon END
    ?>

    <div class="row productdetails-prod">
        <div class="col-xs-6 productdetails-left">
            <div class="productdetails-left-images">
                <?php
                    echo $this->loadTemplate('images');
                    $count_images = count ($this->product->images);
                    if ($count_images > 1) {
                            echo $this->loadTemplate('images_additional');
                    }                
                ?>                
            </div>
			<div>
			<?php 
				// Product Description
				if (!empty($this->product->product_desc))
				{
					?>
					<div class="product-description">
						<?php /** @todo Test if content plugins modify the product description */ ?>
						<span class="title"><?php echo vmText::_('COM_VIRTUEMART_PRODUCT_DESC_TITLE') ?></span>
					<?php echo $this->product->product_desc; ?>
					</div>
					<?php
				} // Product Description END
			?>
			</div>
        </div>
        <div class="col-xs-6 productdetails-right">
            <h3><?php echo $this->product->product_name ?></h3> 
            <?php
                // Product Short Description
                if (!empty($this->product->product_s_desc)) {
                    ?>
                    <div class="product-short-description">
                        <?php
                        /** @todo Test if content plugins modify the product description */
                        echo nl2br($this->product->product_s_desc);
                        ?>
                    </div>
                    <?php
                } // Product Short Description END
            ?>
            <div class="product-prices">
                <h2><?php echo number_format($this->product->prices['salesPrice'], 2, '.', ' '); ?> PLN <?php if($WYPOZYCZALNIA){ echo " / M-C"; } ?></h2>
                <?php 
                    if(!$WYPOZYCZALNIA)
                    {
                        echo shopFunctionsF::renderVmSubLayout('prices',array('product'=>$this->product,'currency'=>$this->currency)); 
                    }
                ?>
            </div>
            <div class="clear"></div>
            <?php 
                if(!$WYPOZYCZALNIA)
                {
                    echo shopFunctionsF::renderVmSubLayout('addtocart',array('product'=>$this->product)); 
                }      
                else
                {
            ?>
                    <hr>
                    <h4 class="text-center">
						Zadzwoń <u>605 150 693</u>, <u>723 400 111</u><br>
                        lub wypłnij formularz
                    </h4>
                    <hr>
                    <form action="<?php echo JUri::current(); ?>" class="form-horizontal" id="wypozyczalnia-form" method="post">
                        <div class="form-group">
                            <label for="inputName" class="col-sm-5 control-label">Imię i nazwisko</label>
                            <div class="col-sm-7">
                                <input type="text" class="form-control" name="inputName" id="inputName" placeholder="Wpisz tu swoje imię i nazwisko" data-validation="length" data-validation-length="min5">
                            </div>                            
                        </div>
                        <div class="form-group">
                            <label for="inputPhone" class="col-sm-5 control-label">Telefon</label>
                            <div class="col-sm-7">
                                <input type="text" class="form-control" name="inputPhone" id="inputPhone" placeholder="Wpisz tu swój numer telefonu" data-validation="length" data-validation-length="min5">
                            </div>                            
                        </div>     
                        <div class="form-group">
                            <label for="inputMsg" class="col-sm-5 control-label">Wiadomość</label>
                            <div class="col-sm-7">
                                <textarea rows="5" class="form-control" name="inputMsg" id="inputMsg" placeholder="Wpisz tu treść wiadomości, która zostanie do nas wysłana" data-validation="length" data-validation-length="min10"></textarea>
                            </div>                            
                        </div>    
                        <div class="form-group hidden">
                            <div class="col-sm-7">
                                <input type="text" class="form-control" name="phone" id="phone" placeholder="Phone">
                            </div>                            
                        </div>                        
                        <div class="form-group">
                            <div class="col-sm-5"></div>
                            <div class="col-sm-7">
                                <input type="submit" value="Wyślij zapytanie" class="btn btn-primary pull-right" />
                            </div>                            
                        </div> 
                        <input type="hidden" name="product" value="<?php echo $this->product->product_name ?>" />
                    </form>
                    <div class="flowFormValidationInfo alert alert-danger" role="alert" style="display: none;"></div>
                    <hr>
            <?php
                }
            ?>
            <?php 
                $fullurl = "http://".$_SERVER['HTTP_HOST'].$_SERVER['REQUEST_URI'];
            ?>
                  
            <div class="text-center">
                <a href="https://www.facebook.com/sharer/sharer.php?u=<?php echo $fullurl; ?>&t=<?php echo $this->product->product_name ?>"
                    
                    target="_blank" title="Share on Facebook" class="btn btn-default">
                    <i class="fa fa-facebook" style="color: #3F5C9A;"></i> Udostępnij
                </a>
                <a href="https://twitter.com/home?status=<?php echo $fullurl; ?>"
                    
                    target="_blank" title="Share on Twitter" class="btn btn-default">
                    <i class="fa fa-twitter" style="color: #55ACEE;"></i> Tweetuj
                </a>   
                <a href="https://plus.google.com/share?url=<?php echo $fullurl; ?>"
                    
                    target="_blank" title="Share on Google+" class="btn btn-default">
                    <i class="fa fa-facebook" style="color: #E03B2A;"></i> Google+
                </a>  
            </div>
                    
            <hr>
                    
            <?php 
            // event onContentBeforeDisplay
            echo $this->product->event->beforeDisplayContent; ?>

            <?php


            echo shopFunctionsF::renderVmSubLayout('customfields', array('product' => $this->product, 'position' => 'normal'));

            // Product Packaging
            $product_packaging = '';
            if ($this->product->product_box)
            {
                ?>
                <div class="product-box">
                    <?php
                    echo vmText::_('COM_VIRTUEMART_PRODUCT_UNITS_IN_BOX') . $this->product->product_box;
                    ?>
                </div>
            <?php } // Product Packaging END ?>

            <?php
            echo shopFunctionsF::renderVmSubLayout('customfields', array('product' => $this->product, 'position' => 'onbot'));

            echo shopFunctionsF::renderVmSubLayout('customfields', array('product' => $this->product, 'position' => 'related_products', 'class' => 'product-related-products', 'customTitle' => true));

            echo shopFunctionsF::renderVmSubLayout('customfields', array('product' => $this->product, 'position' => 'related_categories', 'class' => 'product-related-categories'));

            ?>

            <?php
            // onContentAfterDisplay event
            echo $this->product->event->afterDisplayContent;

            echo $this->loadTemplate('reviews');



            $j = 'jQuery(document).ready(function($) {
	Virtuemart.product(jQuery("form.product"));

	$("form.js-recalculate").each(function(){
		if ($(this).find(".product-fields").length && !$(this).find(".no-vm-bind").length) {
			var id= $(this).find(\'input[name="virtuemart_product_id[]"]\').val();
			Virtuemart.setproducttype($(this),id);

		}
	});
});';
//vmJsApi::addJScript('recalcReady',$j);

            /** GALT
             * Notice for Template Developers!
             * Templates must set a Virtuemart.container variable as it takes part in
             * dynamic content update.
             * This variable points to a topmost element that holds other content.
             */
            $j = "Virtuemart.container = jQuery('.productdetails-view');
Virtuemart.containerSelector = '.productdetails-view';";

            vmJsApi::addJScript('ajaxContent', $j);

            echo vmJsApi::writeJS(); 
            ?>             
            
        </div>
    </div>
    
    <hr>

	

    <?php
    // Product Navigation
    if (VmConfig::get('product_navigation', 1)) {
	?>
        <div class="product-neighbours">
	    <?php
	    if (!empty($this->product->neighbours ['previous'][0])) {
		$prev_link = JRoute::_('index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id=' . $this->product->neighbours ['previous'][0] ['virtuemart_product_id'] . '&virtuemart_category_id=' . $this->product->virtuemart_category_id, FALSE);
		echo JHtml::_('link', $prev_link, $this->product->neighbours ['previous'][0]
			['product_name'], array('rel'=>'prev', 'class' => 'previous-page','data-dynamic-update' => '1'));
	    }
	    if (!empty($this->product->neighbours ['next'][0])) {
		$next_link = JRoute::_('index.php?option=com_virtuemart&view=productdetails&virtuemart_product_id=' . $this->product->neighbours ['next'][0] ['virtuemart_product_id'] . '&virtuemart_category_id=' . $this->product->virtuemart_category_id, FALSE);
		echo JHtml::_('link', $next_link, $this->product->neighbours ['next'][0] ['product_name'], array('rel'=>'next','class' => 'next-page','data-dynamic-update' => '1'));
	    }
	    ?>
    	<div class="clear"></div>
        </div>
    <?php } // Product Navigation END
    ?>    

    <hr>
    <?php
        // Show child categories
        if (VmConfig::get('showCategory', 1))
        {
            echo $this->loadTemplate('showcategory');
        }    
    ?>
    
</div> 





