/*
# @Package: template.
* @Author: Maciej Łotysz
* @Author e-mail: maciejlotysz@gmail.com
* If you want to publish this package on your site you should pleace authors website url witch you can find above.
* You can modify or do what ever you want with this file
*/


jQuery(window).load(function() {
	mapaStartFooter();
	mapaStartKontakt();
});

var mapa;
var domena = 'http://sklepmedycznymragowo.pl/';
var footerMapStyle = [{"featureType":"landscape","stylers":[{"saturation":-100},{"lightness":65},{"visibility":"on"}]},{"featureType":"poi","stylers":[{"saturation":-100},{"lightness":51},{"visibility":"simplified"}]},{"featureType":"road.highway","stylers":[{"saturation":-100},{"visibility":"simplified"}]},{"featureType":"road.arterial","stylers":[{"saturation":-100},{"lightness":30},{"visibility":"on"}]},{"featureType":"road.local","stylers":[{"saturation":-100},{"lightness":40},{"visibility":"on"}]},{"featureType":"transit","stylers":[{"saturation":-100},{"visibility":"simplified"}]},{"featureType":"administrative.province","stylers":[{"visibility":"off"}]},{"featureType":"water","elementType":"labels","stylers":[{"visibility":"on"},{"lightness":-25},{"saturation":-100}]},{"featureType":"water","elementType":"geometry","stylers":[{"hue":"#ffff00"},{"lightness":-25},{"saturation":-97}]}];

function mapaStartKontakt()
{
	var mapCenter=new google.maps.LatLng(53.873541, 21.303631);
	var mapProp = {
	  center:mapCenter,
	  zoom:16,
	  mapTypeId:google.maps.MapTypeId.ROADMAP
	  };

	var map=new google.maps.Map(document.getElementById("mapa"),mapProp);
	
	var kontaktMarker=new google.maps.LatLng(53.872541, 21.303631);
	var marker=new google.maps.Marker({
	  position:kontaktMarker,
	  icon:domena+'templates/creativeroom/images/map-marker.png',
	  });

	marker.setMap(map);

	var infowindow = new google.maps.InfoWindow({
		content:'<h3>Sklep Medyczny Mrągowo</h3>'
				+'<h4>Bowart s.c. Z.G. Liszewscy & J.M. Żbikowscy</h4>'
				+'<span style="font-size: 12px;">ul. Bohaterów Warszawy 13/1b</span><br/>'
				+'<span style="font-size: 12px;">11-700 Mrągowo, woj. warmińsko-mazurskie, Polska </span><br />'
				+'<span style="font-size: 12px;">tel. 605 150 693, 723 400 111</span><br />'
				+'<span style="font-size: 12px;">e-mail: <a style="color: #000000;" href="mailto:sklepmedyczny@bowart.pl">sklepmedyczny@bowart.pl</a></span>'
	  });

	infowindow.open(map,marker);
	
	google.maps.event.addListener(marker, 'click', function() {
	  infowindow.open(map,marker);
	 });	
}

function mapaStartFooter()
{
	var mapCenter=new google.maps.LatLng(53.873541, 21.303631);
	var mapProp = {
	  center:mapCenter,
	  zoom:16,
	  mapTypeId:google.maps.MapTypeId.ROADMAP,
	  styles: footerMapStyle
	  };

	var mapF=new google.maps.Map(document.getElementById("mapa_footer"),mapProp);
	
	var kontaktMarker=new google.maps.LatLng(53.872541, 21.303631);
	var marker=new google.maps.Marker({
	  position:kontaktMarker,
	  icon:domena+'templates/creativeroom/images/map-marker.png',
	  });

	marker.setMap(mapF);

	var infowindow = new google.maps.InfoWindow({
		content:'<h3>Sklep Medyczny Mrągowo</h3>'
				+'<span style="font-size: 12px;">ul. Bohaterów Warszawy 13/1b</span><br/>'
				+'<span style="font-size: 12px;">11-700 Mrągowo</span><br />'
	  });

	infowindow.open(mapF,marker);
	
	google.maps.event.addListener(marker, 'click', function() {
	  infowindow.open(mapF,marker);
	 });	
}
